'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.testEqualsAsync = testEqualsAsync;
exports.testEquals = testEquals;

var _chai = require('chai');

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

// @t "testEqualsAsync" testEqualsAsync() ~equals 1
function testEqualsAsync() {
  return new Promise(function (resolve, reject) {
    resolve(1);
  });
}

// @t "testEquals" testEquals() ~equals { "foo": "bar" }
function testEquals() {
  return { foo: 'bar' };
}

/* istanbul ignore next */

exports.default = function (testDescription, func, argsArray, expected, test) {
  test(testDescription, function () {
    var done = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : _lodash2.default.noop;

    var actual = func.apply(null, argsArray);

    var isPromise = !!actual.then;

    // must eval with var assignment it because eval({foo: 'bar'}) goes bar
    var assert = function assert(value) {
      return (0, _chai.expect)(value).to.eql(eval('var out = ' + expected + '; out'));
    }; // eslint-disable-line no-eval

    if (isPromise) {
      return actual.then(function (actual) {
        assert(actual);
        done();
      });
    }

    assert(actual);
  });
};