'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _enzyme = require('enzyme');

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _chai = require('chai');

var _expandAbbreviation = require('@emmetio/expand-abbreviation');

var _unescape = require('unescape');

var _unescape2 = _interopRequireDefault(_unescape);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

exports.default = function (testDescription, component, argsArray, expected, test) {
  test(testDescription, function () {
    var wrapper = (0, _enzyme.shallow)(_react2.default.createElement(component, argsArray[0]));
    var actual = wrapper.html();
    // emmet formats and indents expansion.
    // therefore, remove the \s using regex
    (0, _chai.expect)((0, _unescape2.default)(actual).replace('/>', '>')).to.equal((0, _expandAbbreviation.expand)(expected).replace(/>(\s)*</g, '><'));
  });
};