'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _path = require('path');

var _path2 = _interopRequireDefault(_path);

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _fs = require('fs');

var _fs2 = _interopRequireDefault(_fs);

var _chai = require('chai');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var getSnapshotDir = function getSnapshotDir() {
  return _path2.default.join(process.cwd(), 'saul_snapshots');
};

// @t "gets file" getSnapshotFile(function tada() {}, 'foo') ~matches-snapshot
var getSnapshotFile = function getSnapshotFile(func, testDescription) {
  return func.name + '-' + _lodash2.default.kebabCase(testDescription) + '.snap';
};

/* istanbul ignore next */

exports.default = function (testDescription, func, argsArray, expected, test, _ref) {
  var getSpy = _ref.getSpy;

  test(testDescription, function () {
    var snapshotPath = _path2.default.join(getSnapshotDir(), getSnapshotFile(func, testDescription));

    var actualContent = JSON.stringify(func.apply(null, argsArray));

    var snapshotContent = void 0;

    try {
      snapshotContent = _fs2.default.readFileSync(snapshotPath);
    } catch (e) {
      _fs2.default.writeFileSync(snapshotPath, actualContent, 'utf-8');
      console.log('New snapshot recorded for ' + func.name + ': ' + testDescription);
    }

    (0, _chai.expect)(snapshotContent).to.eql(actualContent);
  });
};