#!/usr/bin/env node
'use strict';

var _lodash = require('lodash');

var _lodash2 = _interopRequireDefault(_lodash);

var _parse = require('./parse');

var _parse2 = _interopRequireDefault(_parse);

var _organize = require('./organize');

var _organize2 = _interopRequireDefault(_organize);

var _execute = require('./execute');

var _execute2 = _interopRequireDefault(_execute);

var _file = require('./file');

var _config = require('./config');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var safelyExecute = function safelyExecute(fn, taskName) {
  return function () {
    try {
      return fn.apply(undefined, arguments);
    } catch (e) {
      console.error('\x1b[31m', 'Error ' + taskName + ': \n' + e.message);
      console.log('\x1b[0m'); // reset color
      process.exit(1);
    }
  };
};

var processFile = function processFile(path) {
  return (0, _lodash2.default)(path).thru(safelyExecute(_parse2.default, 'parsing files')).thru(function (testParamsArray) {
    return _lodash2.default.map(testParamsArray, safelyExecute(function (params) {
      return (0, _organize2.default)(path, params);
    }, 'organizing tests'));
  }).thru(safelyExecute(_execute2.default, 'executing test')).commit();
};

(0, _file.getTestableFiles)((0, _config.getConfig)().fileGlob).forEach(processFile);